<?php
/**
* @package msta calendar extension
*/

namespace msta\calendar\crons;

class AutoImport extends \phpbb\cron\task\base {
  protected $db;
  protected $log;
  protected $helper;
  protected $request;
  private $table_prefix;

  public function __construct(\phpbb\db\driver\driver_interface $db, \phpbb\log\log_interface $log, \phpbb\routing\helper $helper, \phpbb\request\request $request) {
    $this->db = $db;
    $this->log = $log;
    $this->helper = $helper;
    $this->request = $request;
    $this->table_prefix = substr(USERS_TABLE, 0, -5);
  }

  public function is_runnable () {
    return true;
  }

  public function should_run () {
    $nowTimestamp = intval(date('U'));
    $response = $this->db->sql_query('SELECT topic_id, trigger_pwd, fetch_interval, last_fetch FROM '.$this->table_prefix.'calendar_external');
    while ($row = $this->db->sql_fetchrow($response))
      if (intval($row['fetch_interval']) != 0 && intval($row['last_fetch']) + intval($row['fetch_interval'])*60 <= $nowTimestamp)
        return true;
    return false;
  }

  public function run () {
    $path = explode('?', $this->helper->route('msta_calendar_controller'));
    if (count($path) > 1) {
      $query = explode('&', $path[1]);
      for ($i = 0; $i < count($query); $i++)
        if (substr($query[$i], 0, 4) == 'sid=') {
          array_splice($query, $i, 1);
          break;
        }
    } else $query = array();
    $query[] = 'action=importics';
    $path = (($this->request->is_secure())?'https://':'http://').$this->request->server('HTTP_HOST').$path[0].'?'.join('&', $query);
    $report = array();
    $nowTimestamp = intval(date('U'));
    $response = $this->db->sql_query('SELECT topic_id, trigger_pwd, fetch_interval, last_fetch FROM '.$this->table_prefix.'calendar_external');
    while ($row = $this->db->sql_fetchrow($response))
      if (intval($row['fetch_interval']) != 0 && intval($row['last_fetch']) + intval($row['fetch_interval'])*60 <= $nowTimestamp)
        $report[] = file_get_contents($path.'&id='.$row['topic_id'].'&pwd='.$row['trigger_pwd'])."\n\n";
    $this->log->add('mod', 0, 0, 'LOG_CALENDAR_CRON_IMPORT', false, $report);
  }
}
